<template>
  <div>
    <hero-section
      :title="$t('tea_title')"
    >
      <template #subtitle>
        <span v-html="$t('tea_subtitle')" />
      </template>
    </hero-section>
    <section class="container">
      <main class="content">
        <div class="field is-grouped is-grouped-multiline">
          <div class="control">
            <div
              v-if="query.ingredient"
              class="tags has-addons"
            >
              <span class="tag is-link">{{ $t('filter_by_ingredient') }}</span>
              <nuxt-link
                :to="localePath({ name: 'tea', query: { ...query, ingredient: undefined } })"
                class="tag is-delete"
              />
            </div>
          </div>
        </div>
        <table class="table is-striped is-narrow">
          <thead>
            <tr>
              <th class="is-hidden-mobile">
                {{ $t('shop') }}
              </th>
              <th>{{ $t('name') }}</th>
              <th>{{ $t('who_likes') }}</th>
              <th class="is-hidden-mobile">
                {{ $t('temperature') }}
              </th>
              <th class="is-hidden-mobile">
                {{ $t('duration') }}
              </th>
            </tr>
          </thead>
          <tbody>
            <tr
              v-for="{ slug, shop, who_like, ...row } in list"
              :key="slug"
            >
              <td class="is-narrow is-hidden-mobile">
                {{ shop.name }}
              </td>
              <td>
                <nuxt-link :to="localePath({ name: 'tea-slug', params: { slug } })">
                  {{ row.name }}
                </nuxt-link>
              </td>
              <td class="is-narrow">
                <span
                  v-for="bubble in who_like"
                  :key="bubble.id"
                  :class="tagClassesFromBubbleId(bubble.id)"
                >{{ bubble.name }}</span>
              </td>
              <td class="is-narrow is-hidden-mobile">
                {{ row.celsius }}°C
              </td>
              <td
                v-if="row.max_time_to_infuse === row.min_time_to_infuse"
                class="is-narrow is-hidden-mobile"
              >
                {{ row.min_time_to_infuse }}'
              </td>
              <td
                v-else
                class="is-narrow is-hidden-mobile"
              >
                {{ row.min_time_to_infuse }}' - {{ row.max_time_to_infuse }}'
              </td>
            </tr>
          </tbody>
        </table>
      </main>
    </section>
  </div>
</template>

<script setup>
import { useLocalePath } from '#i18n'

const { fetchTeaList, tagClassesFromBubbleId } = useTea()
const { query } = useRoute()
const localePath = useLocalePath()
const list = await fetchTeaList(query)
</script>

<style lang="scss" scoped>
main {
  margin: 20px 0;
}
</style>
